'UNO_Timer5.BAS  Timer1-Interrupt, ADC0 average
'-------------------------------------------------------------------------------
$regfile = "m328pdef.dat"                                   'ATmega328p
$crystal = 16000000                                         '16 MHz
$baud = 9600

Dim Ticks As Word
Dim Ad As Word
Dim Ad0 As Long
Dim Ad0_mean As Long

Config Lcdpin = Pin , Db4 = Portd.4 , Db5 = Portd.5 , Db6 = Portd.6 , Db7 = Portd.7 , E = Portd.3 , Rs = Portd.2
Config Lcd = 16 * 2
Cls
Cursor Off

Config Adc = Single , Prescaler = 32 , Reference = Internal
Config Portb.2 = Output

Config Timer2 = Timer , Prescale = 64
On Ovf2 Tim2_isr
Enable Timer2
Enable Interrupts

Do
  Disable Interrupts
  Ad0_mean = Ad0_mean * 2443                                'AC
  'Ad0_mean = Ad0_mean * 1100                               'DC
  Ad0_mean = Ad0_mean / 1023
  Ad0_mean = Ad0_mean / 500
  Print Ad0_mean
  Locate 1 , 1
  Lcd Ad0_mean
  Lcd " mV     "
  Enable Interrupts
  Waitms 1000
Loop

Tim2_isr:
  '800 s
  Timer2 = 56
  Portb.2 = 1
  Ticks = Ticks + 1
  Ad = Getadc(0)
  Ad0 = Ad0 + Ad
  If Ticks >= 500 Then
    Ticks = 0
    Ad0_mean = Ad0
    Ad0 = 0
  End If
  Portb.2 = 0
Return

End
