'-------------------------------------------------------------------------------
'UNO_spi3.BAS  SPI Slave
'-------------------------------------------------------------------------------
$regfile = "m328pdef.dat"                                   'ATmega328p
$crystal = 16000000                                         '16 MHz
$baud = 9600

Dim Addr As Byte
Dim B As Bit
Dim Dout As Word
Dim Din As Word
Dim N As Byte
Dim I As Byte


S1 Alias Pinc.0
Portc.0 = 1                                                 'Pullup
S2 Alias Pinc.1
Portc.1 = 1                                                 'Pullup
Sck Alias Pinb.5
Portb.5 = 1
Mosi Alias Pinb.3
Portb.3 = 1
Cs Alias Pinb.2
Portb.2 = 1


Config Lcdpin = Pin , Db4 = Portd.4 , Db5 = Portd.5 , Db6 = Portd.6 , Db7 = Portd.7 , E = Portd.3 , Rs = Portd.2
Config Lcd = 16 * 2

Cls
Cursor Off


Do
  Do
  Loop Until Cs = 0
  Din = 0
  For N = 1 To 10
    Shift Din , Left
    Do
    Loop Until Sck = 1
    Din = Din + Mosi
    Do
    Loop Until Sck = 0
  Next N
  Do
  Loop Until Cs = 1
  Locate 1 , 1
  Lcd Din
  Lcd "    "
  Print Din
Loop

End