'-------------------------------------------------------------------------------
'UNO_spiEE1.BAS  Shift in/out 25LC512
'-------------------------------------------------------------------------------
$regfile = "m328pdef.dat"                                   'ATmega328p
$crystal = 16000000                                         '16 MHz
$baud = 9600

Dim Addr As Byte
Dim B As Bit
Dim Dout As Byte
Dim Din As Byte
Dim N As Byte
Dim I As Word

Declare Sub Spioutin()

S1 Alias Pinc.0
Portc.0 = 1                                                 'Pullup
S2 Alias Pinc.1
Portc.1 = 1
                                               'Pullup
Sck Alias Portb.5
Ddrb.5 = 1
Mosi Alias Portb.3
Ddrb.3 = 1
Cs Alias Portb.2
Ddrb.2 = 1
Miso Alias Pinb.4

Cs = 1
Mosi = 0
Sck = 0

Config Lcdpin = Pin , Db4 = Portd.4 , Db5 = Portd.5 , Db6 = Portd.6 , Db7 = Portd.7 , E = Portd.3 , Rs = Portd.2
Config Lcd = 16 * 2

Cls
Cursor Off


  Cs = 0
  Dout = 6                                                  'write enable
  Spioutin
  Cs = 1
  Waitms 20
  Cs = 0
  Dout = 5                                                  'read status
  Spioutin
  Spioutin
  Cs = 1
  Locate 1 , 1                                              'status 2
  Lcd Din
  Print Din

  Waitms 1000
  Cs = 0
  Dout = 2                                                  'Page Program
  Spioutin
  Dout = 0                                                  'Adr high
  Spioutin
  Dout = 0                                                  'Adr low
  Spioutin
  For I = 0 To 127                                          'page of 128 bytes
    Dout = I
    Spioutin
  Next I
  Cs = 1
  Waitms 20
  Cs = 0
  Dout = 4                                                  'write disable
  Spioutin
  Cs = 1
  Waitms 500
  Cs = 0
  Dout = 3                                                  'read
  Spioutin
  Dout = 0                                                  'A8...A15
  Spioutin
  Dout = 0                                                  'A0...A7
  Spioutin
  I = 0
  Do
    Locate 1 , 1
    Lcd I
    Print I;
    Print "  ";
    I = I + 1
    Spioutin
    Locate 2 , 1
    Lcd Din
    Print Din
    Waitms 200
 Loop


Sub Spioutin
  Din = 0
  For N = 0 To 7
    Shift Din , Left
    Din = Din + Miso
    If Dout.7 = 1 Then Mosi = 1 Else Mosi = 0
    Waitus 3
    Sck = 1
    Waitus 2
    Sck = 0
    Waitus 2
    Shift Dout , Left
  Next N
End Sub